package org.privas.data;

import org.privas.data.ColumnMetaData;
import org.privas.parser.Attribute;

import java.util.ArrayList;
import java.util.List;

public class MetaInfo {

    // table name
    private String name;

    // table column names
    private ArrayList<ColumnMetaData> columnsInfo;

    public MetaInfo(){
        name = "";
        columnsInfo = new ArrayList<ColumnMetaData>();
    }

    public void addColumnName(String columnLabel, String dataTypeLabel, int dataType, int length, int originalPosition, boolean nullable, boolean isQId, boolean isSA, Attribute attribute) {
        ColumnMetaData column = new ColumnMetaData(columnLabel, dataTypeLabel, dataType, length, originalPosition, nullable, isQId, isSA, attribute);
        columnsInfo.add(column);
    }

    public void setName(String tableName) {
        this.name = tableName;
    }

    public String getName() {
        return name;
    }

    public List<ColumnMetaData> getColumnsInfo() {
        return columnsInfo;
    }

    public void setCurrentPosition(String columnLabel, int currentPosition) {
        int columnNumber = getColumnNum(columnLabel);

        columnsInfo.get(columnNumber).setCurrentPosition(currentPosition);
    }

    public int getCurrentColumnPosition(int columnNumber) {
        return columnsInfo.get(columnNumber).getCurrentPosition();
    }

    public int getOriginalColumnPosition(int columnNumber) {
        ColumnMetaData columnMetaData = columnsInfo.stream().filter(e -> e.getCurrentPosition() == columnNumber).findFirst().get();
        return columnMetaData.getOriginalPosition();
    }

    @Override
    public String toString() {
        return "MetaInfo{" +
                "name='" + name + '\'' + "\n" +
                ", columnsInfo=" + columnsInfo +
                '}';
    }

    public int getColumnNum(String name) {

        boolean found = false;
        int index = -1;

        for (int i = 0; !found && i < columnsInfo.size(); i++) {

            found = columnsInfo.get(i).getName().equals(name);

            if(found){
                index = i;
            };
        }

        return index;
    }
}
