package org.privas.data;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class Row {

    // line columns
    private ArrayList<String> columns;

    public Row() {
        columns = new ArrayList<String>();
    }

    public Row(int size) {
        columns = new ArrayList<String>();

        for (int i = 0; i < size; i++) {
            columns.add(null);
        }
    }

    public void addValue(int position, String value) {
        columns.set(position, value);
    }

    public void addValue(String value) {
        columns.add(value);
    }

    public String getValue(int numberColumn) {
        return columns.get(numberColumn);
    }

    public ArrayList<String> getColumns() {
        return new ArrayList<>(columns);
    }

    public String convertToSQL(){
        List<String> columnsSQL = columns.stream().map(e -> "'" + e + "'").collect(Collectors.toList());
        String stringSQL = String.join(",", columnsSQL);

        return "(" + stringSQL + ")";
    }

    @Override
    public String toString() {

        return String.join(",", columns);

    }


}
