package org.privas.data;

import org.privas.parser.PrivacyDefinition;

public class TableDataConnectorFactory implements DataConnectorFactory<TableData> {

    public Extractor<TableData> getExtractor(PrivacyDefinition privacyDefinition) {
        if (privacyDefinition.getRepositoryType() == RepositoryType.MYSQL) {
//            handleRelationalMysql(privacyDefinition);
        }
        else  if (privacyDefinition.getRepositoryType() == RepositoryType.CSV) {
            return new CSVExtractor(privacyDefinition);
        }

        return null;
    }

    public Exporter<TableData> getExporter(PrivacyDefinition privacyDefinition) {
        if (privacyDefinition.getRepositoryType() == RepositoryType.MYSQL) {
//            handleRelationalMysql(privacyDefinition);
        }
        else  if (privacyDefinition.getRepositoryType() == RepositoryType.CSV) {
            return new CSVExporter(privacyDefinition);
        }

        return null;
    }
}
