package org.privas.parser;

import java.util.List;
import java.util.Optional;

public class GeneralizationNodeRange extends GeneralizationNode {

    private Range range;

    public GeneralizationNodeRange(GeneralizationNode parent, String label, Range range) {
        super(parent, label, true);
        this.range = range;
    }

    public Range getRange() {
        return range;
    }

    public void setRange(Range range) {
        this.range = range;
    }

    public Optional<GeneralizationNode> getGeneralizationFor(String value) {
        if (covers(value)) {
            return Optional.of(this);
        }

        return Optional.empty();
    }

    public boolean covers(String valueRaw) {
        try {
            double value = Double.parseDouble(valueRaw);

            if (range.contains(value)) {
                return true;
            }
        } catch (NumberFormatException e) {
            return false;
        }

        return false;
    }
}
