package org.privas.parser;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

public class GeneralizationNodeSetValues extends GeneralizationNode {

    public List<String> values;

    public GeneralizationNodeSetValues(GeneralizationNode parent, String label) {
        super(parent, label, true);

        this.values = new ArrayList<>();
    }

    public void add(String value) {
        this.values.add(value);
    }

    public Optional<GeneralizationNode> getGeneralizationFor(String value) {
        if (covers(value)) {
            return Optional.of(this);
        }

        return Optional.empty();
    }

    public boolean covers(String value) {
        return value.contains(value);
    }
}
