package org.privas.parser;

import java.util.List;
import java.util.stream.Collectors;

import static org.privas.parser.ParserErrorType.*;

public class ParserErrorMapper {

    public static List<String> mapErrors(List<ParserError> errors) {
        return errors.stream().map(ParserErrorMapper::mapError).collect(Collectors.toList());
    }

    public static String mapError(ParserError error) {
        if (error.is(MISSING_ATTACK_MODELS)) {
            return "No attack models defined. At least one should be configured";
        }
        else if (error.is(INVALID_ATTACK_MODELS_COMBINATION)) {
            return "The selected `"+ error.getValue() +"` combination is not supported. Available combinations are (recordLinkage, recordLinkage+attributeLinkage, tableLinkage+probabilisticAttack, and attributeLinkage+probabilisticAttack)";
        }
        else if (error.is(GENERALIZATION_NAME_DUPLICATED)) {
            return "The `"+ error.getValue() +"` generalization name is duplicated.";
        } else {
            return "The `"+ error.getValue() +"` generalization alias is duplicated.";
        }
    }
}
