package org.privas.parser;

public class Range {
    private boolean leftInclusive;
    private boolean rightInclusive;
    private double leftValue;
    private double rightValue;

    public Range(Double leftValue, Double rightValue, boolean leftInclusive, boolean rightInclusive) {
        this.leftValue = leftValue == null ? Double.MIN_VALUE : leftValue;
        this.rightValue = rightValue == null ? Double.MAX_VALUE : rightValue;
        this.leftInclusive = leftInclusive;
        this.rightInclusive = rightInclusive;
    }

    public boolean isLeftInclusive() {
        return leftInclusive;
    }

    public boolean isRightInclusive() {
        return rightInclusive;
    }

    public double getLeftValue() {
        return leftValue;
    }

    public double getRightValue() {
        return rightValue;
    }

    public boolean contains(double value) {
        if (leftInclusive && rightInclusive) {
            return value >= leftValue && value <= rightValue;
        }
        else if (leftInclusive) {
            return value >= leftValue && value < rightValue;
        }
        else if (rightInclusive) {
            return value > leftValue && value <= rightValue;
        }
        else {
            return value > leftValue && value < rightValue;
        }
    }
}
