package org.privas.runtime;

import org.privas.parser.PrivacyDefinition;
import org.privas.data.TableData;
import org.privas.techniques.*;

public class DecisionEngine {
    public Model<TableData> getModel(PrivacyDefinition privacyDefinition) {
        int type = privacyDefinition.getType();

        if (type == 1) {
            return new KAnonymity(2);
        }
        else if (type == 2) {
            if (privacyDefinition.getTableToPrivateDetails().get(0).getAttributesOptions().hasSensitiveAttributes()) {
                return new LDiversity(2);
            }
            else {
                return new KAnonymity(2);
            }
        }
        else if (type == 3) {
            return new TCloseness(0.1);
        }
        else if (type == 4) {
            return new EDifferentialPrivacy(0.1);
        }

        return new KAnonymity(2);
    }
}
