package org.privas.techniques;

public class CurrentGeneralization {
    private String value;
    private int totalPossibleGeneralizations;
    private int nrGeneralizationsNotMade;

    public CurrentGeneralization(String value, int totalPossibleGeneralizations) {
        this.value = value;
        this.totalPossibleGeneralizations = totalPossibleGeneralizations;
        nrGeneralizationsNotMade = 0;
    }

    public CurrentGeneralization(CurrentGeneralization currentGeneralization) {
        this(currentGeneralization.getValue(), currentGeneralization.getTotalPossibleGeneralizations(), currentGeneralization.getNrGeneralizationsNotMade());
    }

    private CurrentGeneralization(String value, int totalPossibleGeneralizations, int nrGeneralizationsNotMade) {
        this(value, totalPossibleGeneralizations);
        this.nrGeneralizationsNotMade = nrGeneralizationsNotMade;
    }

    public CurrentGeneralization setValue(String value) {
        int nrGeneralizationsNotMade = this.nrGeneralizationsNotMade + 1;

        return new CurrentGeneralization(value, totalPossibleGeneralizations, nrGeneralizationsNotMade);
    }

    public String getValue() {
        return value;
    }

    public int getTotalPossibleGeneralizations() {
        return totalPossibleGeneralizations;
    }

    public int getNrGeneralizationsNotMade() {
        return nrGeneralizationsNotMade;
    }

    public double getInformationLossRatio() {
        int generalizationsMade = totalPossibleGeneralizations - nrGeneralizationsNotMade;

        return (generalizationsMade * 1d) / (generalizationsMade + 1);
    }

    @Override
    protected CurrentGeneralization clone() {
        return new CurrentGeneralization(this);
    }
}
