package org.privas.techniques;

import org.privas.data.TableData;

import java.util.List;

public class EDifferentialPrivacy extends Model<TableData> {
    private double e;

    public EDifferentialPrivacy(double e) {
        super();

        this.e = e;

        double t = Math.exp(e / 2);

        Technique<TableData> technique = new MondrianTCloseness(t);

        super.addTechnique(technique);
    }

    @Override
    public void addData(TableData o) {
        List<Technique<TableData>> t = this.getTechniques();

        t.get(0).addData(o);
    }

    @Override
    public void apply() {
        List<Technique<TableData>> t = this.getTechniques();

        t.get(0).apply();
    }

    @Override
    public TableData getDataTransformed() {
        List<Technique<TableData>> t = this.getTechniques();

        return t.get(0).getDataTransformed();
    }
}
