package org.privas.techniques;

import org.privas.data.TableData;

import java.util.List;

public class KAnonymity extends Model<TableData> {

    private int k;

    public KAnonymity(int k) {
        super();

        this.k = k;

        Technique<TableData> techniqueMondrian = new Mondrian(k);
        super.addTechnique(techniqueMondrian);
    }

    @Override
    public void addData(TableData o) {
        List<Technique<TableData>> t = this.getTechniques();

        t.get(0).addData(o);
    }

    @Override
    public void apply() {
        List<Technique<TableData>> t = this.getTechniques();

        t.get(0).apply();
    }

    @Override
    public TableData getDataTransformed() {
        List<Technique<TableData>> t = this.getTechniques();

        return t.get(0).getDataTransformed();
    }
}
