package org.privas.techniques;

import org.privas.data.Data;

import java.util.ArrayList;
import java.util.List;

public abstract class Model<TData extends Data> {

    private List<Technique<TData>> techniques;

    public Model() {
        this.techniques = new ArrayList<>();
    }

    protected void addTechnique(Technique<TData> technique) {
        techniques.add(technique);
    }

    public List<Technique<TData>> getTechniques() {
        return techniques;
    }

    public abstract void addData(TData data);

    public abstract void apply();

    public abstract TData getDataTransformed();
}
