package org.privas.techniques;

import org.privas.data.TableData;

import java.util.List;

public class TCloseness extends Model<TableData> {
    private double t;

    public TCloseness(double t) {
        super();

        this.t = t;

        Technique<TableData> technique = new MondrianTCloseness(t);

        super.addTechnique(technique);
    }

    @Override
    public void addData(TableData o) {
        List<Technique<TableData>> t = this.getTechniques();

        t.get(0).addData(o);
    }

    @Override
    public void apply() {
        List<Technique<TableData>> t = this.getTechniques();

        t.get(0).apply();
    }

    @Override
    public TableData getDataTransformed() {
        List<Technique<TableData>> t = this.getTechniques();

        return t.get(0).getDataTransformed();
    }
}
